functor PPrint(LambdaAst : LAMBDAAST) : PPRINT = struct
  
  structure LambdaAst = LambdaAst

  fun pprintVar x = print x

  local 
      open LambdaAst
  in
  fun pprintType t = pprintType'(0, t)
  and pprintExpr e = pprintExpr'(0, e)
  and NSpace 0 = ()
    | NSpace n = (print " "; NSpace(n-1))
		 		 
  and pprintType'(n, (IntType)) = print "int"
    | pprintType'(n, (BoolType)) = print "bool"
    | pprintType'(n, (ArrowType(t1,t2))) = (print "(";pprintType'(n, t1); print " -> "; pprintType'(n, t2); print ")")
    | pprintType'(n, (ProdType(t1,t2))) = (print "(";pprintType'(n, t1); print " * "; pprintType'(n, t2); print ")")
    | pprintType'(n, (TypeVar(s))) = (print "'";print s)

  and	pprintExpr'(n, (True)) = print "true"
      | pprintExpr'(n, (False)) = print "false"
      | pprintExpr'(n, (Var x)) = pprintVar x
      | pprintExpr'(n, (Int(i))) = print (Int.toString i)
      | pprintExpr'(n, (If(b,e1,e2))) = (print "(if "; pprintExpr'(n,b); print " then "; 
					 pprintExpr'(n,e1); print " else "; pprintExpr'(n,e2); print ")")
      | pprintExpr'(n, (Plus(e1, e2)))  = (print "("; pprintExpr'(n, e1); print " + "; pprintExpr'(n, e2); print ")")
      | pprintExpr'(n, (Pair(e1, e2)))  = (print "("; pprintExpr'(n, e1); print ", "; pprintExpr'(n, e2); print ")")
      | pprintExpr'(n, (Fst(e)))  = (print "(fst "; pprintExpr'(n, e); print ")")
      | pprintExpr'(n, (Snd(e)))  = (print "(snd "; pprintExpr'(n, e); print ")")
      | pprintExpr'(n, (Apply(e1, e2)))  = (print "("; pprintExpr'(n, e1); print " "; pprintExpr'(n, e2); print ")")
      | pprintExpr'(n, (Lambda(x, e)))  = (print "(lambda "; pprintVar x; print ". "; pprintExpr'(n, e); print ")")
      | pprintExpr'(n, (TypedLambda(x, t, e)))  = (print "(lambda "; pprintVar x; print " : "; pprintType'(n, t);  print ". "; pprintExpr'(n, e); print ")")
      | pprintExpr'(n, (Let(x, e1, e2)))  = (print "let "; pprintVar x; print " = "; pprintExpr'(n, e1);  print " in \n"; NSpace (n+2); pprintExpr'(n+2, e2); print "\n"; NSpace n; print " end")
				    
  end
      
end


